program BNHelico
  use sep
  use bnhelix
  use bcreatenhelixmod
  use bnhelicon
  use bnpolydiv

  implicit none
  integer                             :: n123, dim, i, nf, nbf, nbp, np123, ip, id, hrd, hel,stat
  integer, dimension (:), allocatable :: n, a, center, gap, lag, pch, nh, ipp, np, npa, ii, cd, pp
  real,    dimension (:),    pointer  :: xx
  real,    dimension (:), allocatable :: npd, yy
  real,    dimension(:,:), allocatable :: coefs
  type(bnfilter)                       :: nsaa
  character (len = 6)                 :: varname
  real                                :: eps
  logical                             :: adj,inv
  call sep_init (SOURCE)
  dim = sep_dimension ()
  allocate (n (dim), a (dim), center (dim), gap (dim), npa(dim), npd(dim), ii(dim),cd(dim), np(dim))
  call from_history (n); n123 = product (n)
  call to_history ("n",n)
  call from_aux ("pef","a", a)
  center=1; where (a (2:) > 1) center (:dim-1) = a (:dim-1)/2+1
  call from_aux ("pef","center", center, center)
  gap = 0
  call from_aux ("pef","gap", gap, gap)

  allocate (xx(n123), yy(n123))
  call sep_read (xx)

! make patch table, or read patch table
  allocate (pp (n123), ipp(n123)) 
  np=0
  if (exist_file ("pch")) then
!     call sep_read (pp, "pch")
     call from_aux("pch","np",npd)
     np=int(n/int(npd))
     ipp=int(pp)
     np123 = maxval (pp)
  else
     pp=0
     npa=1
     call from_aux("pef","np",npa,npa)
     write(0,*)"npa",npa,n
     np=int(n/npa)
     write(0,*)"np",np,"n123",n123
     do ip=1,n123
        call line2cart(n,ip,ii)
        do id=1,dim
           cd(id)=int((ii(id)-1)/npa(id))+1
        end do 
        call cart2line(np,cd,hel)
        pp(ip)=hel
     end do
     ipp=int(pp)
     np123 = maxval(ipp)
  end if

  nsaa = bcreatenhelix( n, center, gap, a, pp)    ! allocate PEF
  deallocate (pp)
  call from_par( "adj", adj,.false. )
  call from_par ("inv", inv,.false.)
  call sep_read(nsaa%flt,"pef")

  if (inv) then
     call bnpolydiv_init(n(1),nsaa)
     if (adj) then
        stat=bnpolydiv_lop(.true.,.false.,yy,xx)
     else
        stat=bnpolydiv_lop(.false.,.false.,xx,yy)
     end if
  else
     call bnhelicon_init(nsaa)
     if (adj) then
        stat=bnhelicon_lop(.true.,.false.,yy,xx)
     else
        stat=bnhelicon_lop(.false.,.false.,xx,yy)
     end if
  end if
  call sep_write(yy)
  call sep_close ()
  call exit (0)
end program BNHelico
