program cc_surface
use sep3d_struct_mod
use sep
implicit none
type(sep3d):: primary,multiple,fftprimary,fftmultiple,cc_pm,ccr_pm

integer ::nt,nw,nw_block,nblock,n_h,n_x, block_size,real_block_size
integer ::iw_min,iw_max,isx,i_prim,i_mult,i_m_x,i_h_x,n_block,iw,iblock
integer :: tmp_iw_min,tmp_iw_max,fftprimary_blocksize,fftmultiple_blocksize
real :: hmin,hmax,o_s_x,d_s_x,s_x
integer :: n_s_x,i_s_x
real ::h_min,h_max,d_h,x_min,x_max,f_min,f_max,d_x,dt,dw
real ::m_x,h_x,prim_x,mult_x
real,pointer    :: tmp_prim(:)
complex,pointer ::prim(:,:),mult(:,:),tmp_fft(:),c_c_tmp(:,:,:)
real :: lambda
real, allocatable :: mean(:)
logical :: dec,timedomain,splitspread,needfft
integer,external :: sreed,srite,sseek_block,auxin

call initpar()
call from_param("f_min",f_min,5.0); call from_param("f_max",f_max,55.0);call from_param("nblock",nblock,8)
call from_param("lambda",lambda,0.001); call from_param("dec",dec,.false.)
call from_param("timedomain",timedomain,.false.)
call from_param("splitspread",splitspread,.false.)
call from_param("needfft",needfft,.true.)


if(-1 .eq. auxin("Primary") ) call seperr("Must provide Primary")
if (-1 .eq. auxin("Mutiple") ) call seperr("Must provide Mutiple")
call init_sep3d("Primary",primary,"INPUT"); call init_sep3d("Mutiple",multiple,"INPUT")

if (primary%n(1)/=multiple%n(1).OR.primary%n(2)/=multiple%n(2).OR.primary%n(3)/=multiple%n(3) &
 .OR. primary%o(1)/=multiple%o(1).OR.primary%o(2)/=multiple%o(2).OR.primary%o(3)/=multiple%o(3)&
 .OR. primary%d(1)/=multiple%d(1).OR.primary%d(2)/=multiple%d(2).OR.primary%d(3)/=multiple%d(3) ) then
 write(0,*) "the structure is not same between primary and multiple" 
! return
end if

allocate(mean(primary%n(2)))

dt=primary%d(1); nt=primary%n(1);dw=2.0*3.1415926/(2*nt*dt)
iw_min=2.0*3.1415926*f_min/dw; iw_max=2.0*3.1415926*f_max/dw-1; nw=iw_max-iw_min+1
nw_block=nw/nblock
real_block_size=primary%n(1)*4
if ( needfft) then
  call init_sep3d(fftprimary,"OUTPUT","COMPLEX","REGULAR",ctag="FFTprimary"); call axis_allocate(fftprimary,3)
  fftprimary%n(1)=primary%n(2); fftprimary%d(1)=primary%d(2); fftprimary%o(1)=primary%o(2)
  fftprimary%n(2)=nw          ; fftprimary%d(2)=dw          ; fftprimary%o(2)=iw_min*dw
  fftprimary%n(3)=primary%n(3); fftprimary%d(3)=primary%d(3); fftprimary%o(3)=primary%o(3)
  call sep3d_set_sep3d(fftprimary); call sep3d_write_description("FFTprimary",fftprimary)

  call init_sep3d(fftmultiple,"OUTPUT","COMPLEX","REGULAR",ctag="FFTmultiple")
  call axis_allocate(fftmultiple,3)
  fftmultiple%n(1)=multiple%n(2); fftmultiple%d(1)=multiple%d(2); fftmultiple%o(1)=multiple%o(2)
  fftmultiple%n(2)=nw          ;  fftmultiple%d(2)=dw          ; fftmultiple%o(2)=iw_min*dw
  fftmultiple%n(3)=multiple%n(3); fftmultiple%d(3)=multiple%d(3); fftmultiple%o(3)=multiple%o(3)
  call sep3d_set_sep3d(fftmultiple); call sep3d_write_description("FFTmultiple",fftmultiple)
end if
call init_sep3d(cc_pm,"OUTPUT","COMPLEX","REGULAR",ctag="CC"); call axis_allocate(cc_pm,3) ! t,h,x

hmax= primary%d(2)*(primary%n(2)-1)
hmin=-primary%d(2)*(primary%n(2)-1)
d_h=primary%d(2)
n_h=(hmax-hmin)/d_h+1


o_s_x=primary%o(3)
d_s_x=primary%d(2)
n_s_x=(primary%o(3)+(primary%n(3)-1)*primary%d(3)-o_s_x)/d_s_x

cc_pm%o(1)=hmin;     cc_pm%d(1)=d_h;  cc_pm%n(1)=n_h
cc_pm%o(2)=o_s_x;     cc_pm%d(2)=d_s_x;  cc_pm%n(2)=n_s_x
cc_pm%o(3)=iw_min*dw; cc_pm%d(3)=dw;   cc_pm%n(3)=nw
call sep3d_set_sep3d(cc_pm); call sep3d_write_description("CC",cc_pm)

block_size=n_h*n_s_x*nw_block*8
allocate(c_c_tmp(n_h,n_s_x,nw_block))
allocate(prim(primary%n(2),nw),mult(multiple%n(2),nw),tmp_prim(primary%n(1)), tmp_fft(primary%n(1)*2) )

do iblock=1,nblock
  do isx=1,primary%n(3)
    if (sseek_block("Primary",isx-1,primary%n(1)*primary%n(2)*4,0)/=isx-1 ) call seperr("error seek1")
    if (sseek_block("Mutiple",isx-1,multiple%n(1)*multiple%n(2)*4,0)/=isx-1 ) call seperr("error seek m")
    do i_prim=1,primary%n(2)
      if(sreed("Primary",tmp_prim,real_block_size)/=real_block_size )call seperr("Error reading primary")
      tmp_fft=0.0; tmp_fft(1:primary%n(1))=cmplx(tmp_prim(:),0)
      call CFFT1DE(tmp_fft(:),2*primary%n(1),1)
      prim(i_prim,:)=tmp_fft(iw_min:iw_max); mean(i_prim)=0.0
    end do
    do i_mult=1,multiple%n(2)
      if(sreed("Mutiple",tmp_prim,real_block_size)/=real_block_size)call seperr("Error reading multiple")
      tmp_fft=0.0; tmp_fft(1:multiple%n(1))=cmplx(tmp_prim(:),0)
      call CFFT1DE(tmp_fft(:),2*multiple%n(1),1)
      mult(i_mult,:)=tmp_fft(iw_min:iw_max)
    end do

    tmp_iw_min=(iblock-1)*nw_block+1
    tmp_iw_max=tmp_iw_min+nw_block-1
    write(*,*) "isx",isx,"iblock",iblock
    do i_prim=1,primary%n(2)
      if (splitspread) then
        prim_x=primary%o(2)+(i_prim-1)*primary%d(2)
      else
        prim_x=(isx-1)*primary%d(3)+primary%o(3)+primary%o(2)+(i_prim-1)*primary%d(2)
      end if
      do i_mult=1,multiple%n(2)
        if (splitspread) then
          mult_x=multiple%o(2)+(i_mult-1)*multiple%d(2)
        else
          mult_x=(isx-1)*multiple%d(3)+multiple%o(3)+multiple%o(2)+(i_mult-1)*multiple%d(2)
        end if
        s_x=prim_x; h_x=mult_x-prim_x
        i_s_x=(s_x-cc_pm%o(2))/cc_pm%d(2)+1; i_h_x=(h_x-cc_pm%o(1))/cc_pm%d(1)+1
        if (i_s_x > 0 .and. i_s_x <=n_s_x .and. i_h_x >0 .and. i_h_x <n_h) then
          c_c_tmp(i_h_x,i_s_x,:)=c_c_tmp(i_h_x,i_s_x,:)+&
          mult(i_mult,tmp_iw_min:tmp_iw_max)*conjg(prim(i_prim,tmp_iw_min:tmp_iw_max))
        end if 
      end do
    end do
  end do
  if (srite("CC",c_c_tmp,block_size)/=block_size) call seperr("Error writing in cc_pm")
end do


deallocate(tmp_prim,tmp_fft,prim,mult,c_c_tmp,mean)
end program cc_surface
